#!/bin/bash

# Title in Bootloader
TITLE="Glitchd Void"

# Filename of ISO file
FILENAME="glitchd-voidlinux_jan-4-2017_${ARCH}.iso"

# System architecture
ARCH="i686"

# Local Language
LOCALE="en_US.UTF-8"

# Keyboard Layout
KEYMAP="us"

# Compression type of initramfs
INITRAMFS_COMP="xz"

# Compression type of squashfs
SQUASHFS_COMP="xz"

# Cache directory
CACHEDIR="/var/cache/xbps"

# List of packages to include
PACKAGES='
xorg 
lxdm 
xfce4 
xfce4-whiskermenu-plugin 
xfce4-mixer
xfce4-pulseaudio-plugin
faenza-icon-theme
alsa-utils
pulseaudio
NetworkManager
linux-firmware-network
linux-tools
clementine
cmus
fuse
ntfs-3g
thunar-archive-plugin
e2fsprogs
hfsprogs
audacity
pluma
mplayer
mpv
lua52
lua52-devel
smplayer
network-manager-applet
gnome-keyring
net-tools
nmap
iotop
htop
git
grub
dialog
openssh
virtualbox-ose
deluge
python
hexchat
filezilla
chromium
mumble
gparted
pcmanfm
dhcpcd
pianobar
void-repo-nonfree
k3b'


########################################
## LEAVE THE BELOW COMMANDS ALONE     ##
## UNLESS YOU KNOW WHAT YOU ARE DOING ##
########################################

./mklive.sh\
    -T "${TITLE}"\
    -o "${FILENAME}"\
    -a "${ARCH}"\
    -l "${LOCALE}"\
    -k "${KEYMAP}"\
    -i "${INITRAMFS_COMP}"\
    -s "${SQUASHFS_COMP}"\
    -c "${CACHEDIR}"\
    -p "${PACKAGES}"
