#!/bin/bash

flatpakBin=$(which -a flatpak)
checkApt=$(which -a apt)
checkXbps=$(which -a xbps)
installFlatpak(){
    if [ ! ${flatpakBin} ];then
        if [ ${checkXbps} ];then
            sudo xbps-install -S flatpak

        elif [ ${checkApt} ];then
            printf "\nChecking for PPA\n"
            if [ ! -f /etc/apt/sources.list.d/alexlarsson-ubuntu-flatpak-xenial.list ];then
                printf "\nInstalling PPA\n"
                sudo add-apt-repository ppa:alexlarsson/flatpak
                sudo apt update
                sudo apt install flatpak
            else
                sudo apt install flatpak
            fi
        else
            printf "\nUnsupported Operating System"
        fi
    else
        printf "\nFlatpak is already installed\n"
    fi
}

addFlatpakRepo(){

    if [  $(which -a flatpak) ];then 
        printf "\nAdding Flathub Repository..\n"
        flatpak remote-add --if-not-exists flathub https://flathub.org/repo/flathub.flatpakrepo
    else
        echo "Flatpak is not installed"
    fi
}

getPackages(){
    printf "\nInstalling Gradio..\n"
    flatpak install flathub de.haeckerfelix.gradio

    printf "\nInstalling Adapta Theme...\n"
    flatpak install flathub org.gtk.Gtk3theme.Adapta-Nokto-Eta
}

installFlatpak
addFlatpakRepo
getPackages